automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: Exit on error when whitespace follows trailing backslash


From: Alexandre Duret-Lutz
Subject: Re: Exit on error when whitespace follows trailing backslash
Date: Thu, 03 Apr 2003 00:55:54 +0200
User-agent: Gnus/5.090016 (Oort Gnus v0.16) Emacs/21.2 (gnu/linux)

>>> "Peter" == Peter Muir <address@hidden> writes:

 Peter> PROBLEM

 Peter> $make
 Peter> Makefile:xxx: *** missing separator.
 Peter> Stop.
 Peter> $

 Peter> I was editing a Makefile.am outside of the
 Peter> Emacs makefile-mode. In a series of
 Peter> continued lines, I had put a space after a
 Peter> trailing backslash.

Thanks for the report and the patch.  (And sorry for the late answer.)

I'll install the following patch on HEAD and branch-1-7.
This is a variation of yours where trailing spaces are
stripped, so that the error can be turned into a warning.

The two calls to check_trailing_slash should be replaced by
        $saw_bk = check_trailing_slash ("$amfile:$.", $_);
and
        $saw_bk = check_trailing_slash ($here, $_);
on branch-1-7.

(I'll install the patch tomorrow, make check is sill running and
it's bedtime...)

2003-04-03  Alexandre Duret-Lutz  <address@hidden>

        * automake.in (check_trailing_slash): New function (variation on
        a patch by Peter Muir).  Diagnose whitespaces following trailing
        backslash.
        (read_am_file): Use it.
        * tests/backsl4.test: New file.
        * tests/Makefile.am (TESTS): Add backsl4.test.
        Reported by Peter Muir.

Index: automake.in
===================================================================
RCS file: /cvs/automake/automake/automake.in,v
retrieving revision 1.1438
diff -u -r1.1438 automake.in
--- automake.in 14 Mar 2003 21:46:57 -0000      1.1438
+++ automake.in 2 Apr 2003 22:40:01 -0000
@@ -7365,6 +7365,25 @@
 
 ################################################################
 
+# &check_trailing_slash ($WHERE, $LINE)
+# --------------------------------------
+# Return 1 iff $LINE ends with a slash.
+# Might modify $LINE.
+sub check_trailing_slash ($\$)
+{
+  my ($where, $line) = @_;
+
+  # Ignore `##' lines.
+  return 0 if $$line =~ /$IGNORE_PATTERN/o;
+
+  # Catch and fix a common error.
+  msg "syntax", $where, "whitespace following trailing backslash"
+    if $$line =~ s/\\\s+\n$/\\\n/;
+
+  return $$line =~ /\\$/;
+}
+
+
 # &append_comments ($VARIABLE, $SPACING, $COMMENT)
 # ------------------------------------------------
 # Append $COMMENT to the other comments for $VARIABLE, using
@@ -7437,7 +7456,7 @@
        {
            last;
        }
-       $saw_bk = /\\$/ && ! /$IGNORE_PATTERN/o;
+       $saw_bk = check_trailing_slash ($where, $_);
     }
 
     # We save the conditional stack on entry, and then check to make
@@ -7464,7 +7483,7 @@
        $_ =~ s/address@hidden@//g
            unless $seen_maint_mode;
 
-       my $new_saw_bk = /\\$/ && ! /$IGNORE_PATTERN/o;
+       my $new_saw_bk = check_trailing_slash ($where, $_);
 
        if (/$IGNORE_PATTERN/o)
        {
Index: tests/Makefile.am
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.am,v
retrieving revision 1.476
diff -u -r1.476 Makefile.am
--- tests/Makefile.am   14 Mar 2003 21:55:00 -0000      1.476
+++ tests/Makefile.am   2 Apr 2003 22:40:02 -0000
@@ -42,6 +42,7 @@
 backsl.test \
 backsl2.test \
 backsl3.test \
+backsl4.test \
 badline.test \
 badprog.test \
 block.test \
Index: tests/backsl4.test
===================================================================
RCS file: tests/backsl4.test
diff -N tests/backsl4.test
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/backsl4.test  2 Apr 2003 22:40:02 -0000
@@ -0,0 +1,50 @@
+#! /bin/sh
+# Copyright (C) 2003  Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Automake; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Make sure we diagnose and fix white spaces following backslash.
+# Report from Peter Muir.
+
+. ./defs || exit 1
+
+set -e
+
+echo AC_OUTPUT >>configure.in
+
+# Note: trailing whitespaces used during the test should not appear as
+# trailing whitespaces in this file, or they will get stripped by any
+# reasonable editor.
+
+echo 'bin_SCRIPTS = foo \ ' >Makefile.am
+cat >>Makefile.am <<'END'
+bar
+ok:
+       :
+END
+echo 'data_DATA = baz \  ' >>Makefile.am
+echo ' fum' >>Makefile.am
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE 2>stderr && exit 1
+grep ':1:.*whitespace' stderr
+grep ':5:.*whitespace' stderr
+./configure
+# Older versions of Automake used to produce invalid Makefiles such input.
+$MAKE ok

-- 
Alexandre Duret-Lutz





reply via email to

[Prev in Thread] Current Thread [Next in Thread]